package cn.iocoder.yudao.module.bpm.controller.admin.oa;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.shiftjobs.BpmOAShiftjobsCreateReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.shiftjobs.BpmOAShiftjobsRespVO;
import cn.iocoder.yudao.module.bpm.convert.oa.BpmOAShiftjobsConvert;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAShiftjobsDO;
import cn.iocoder.yudao.module.bpm.service.oa.BpmOAShiftjobsService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;
import static cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils.getLoginUserId;

/**
 * OA 调岗申请 Controller
 *
 * @author 符溶馨

 */
@Tag(name = "管理后台 - OA 调岗申请")
@RestController
@RequestMapping("/bpm/oa/shiftjobs")
@Validated
public class BpmOAShiftjobsController {

    @Resource
    private BpmOAShiftjobsService shiftjobsService;

    @PostMapping("/create")
    @Operation(summary = "创建请求申请")
    public CommonResult<Long> createShiftjobs(@Valid @RequestBody BpmOAShiftjobsCreateReqVO createReqVO) {

        return success(shiftjobsService.createShiftjobs(getLoginUserId(), createReqVO));
    }

    @GetMapping("/get")
    @Operation(summary = "获得用章申请")
    @Parameter(name = "id", description = "编号", required = true, example = "1024")
    public CommonResult<BpmOAShiftjobsRespVO> getShiftjobs(@RequestParam("id") Long id) {

        BpmOAShiftjobsDO shiftjobs = shiftjobsService.getShiftjobs(id);

        return success(BpmOAShiftjobsConvert.INSTANCE.convert(shiftjobs));
    }
}
